%define is_mandrake %(test -e /etc/mandrake-release && echo 1 || echo 0)
%define is_mandriva %(test -e /etc/mandriva-release && echo 1 || echo 0)
%define is_suse %(test -e /etc/SuSE-release && echo 1 || echo 0)
%define is_fedora %(test -e /etc/fedora-release && echo 1 || echo 0)
%define is_centos %(grep CentOS /etc/redhat-release >/dev/null 2>&1 && echo 1 || echo 0)

%define dist redhat
%define disttag rh

%if %is_mandrake
%define dist mandrake
%define disttag mdk
%endif
%if %is_mandriva
%define dist mandriva
%define disttag mdk
%endif
%if %is_suse
%define dist suse
%define disttag suse
%endif
%if %is_fedora
%define dist fedora
%define disttag fc
%endif
%if %is_centos
%define dist centos
%define disttag centos
%endif


%define distver %(release="`rpm -q --queryformat='%{VERSION}' %{dist}-release 2> /dev/null | tr . : | sed s/://g`" ; if test $? != 0 ; then release="" ; fi ; echo "$release")


Summary: Unity Asset Server
Name: unity_asset_server
Version: 1.0.0
Release: 1.%{disttag}%{distver}
Copyright: Freely Redistributable
Packager: Unity Technologies <support@unity3d.com>
Group: Development/Version Control
URL: http://www.unity3d.com/
Source: http://www.unity3d.com/assetserver/%{name}-%{version}.tgz
BuildRoot: /var/tmp/assetserver-rpmroot
BuildRequires: perl
BuildRequires: bison

%description

Unity Asset Server enables version control of unity project directories.
Using the Asset Server requires a Unity installation on the client machine
with an Asset Server client license.


%package devel
Summary: Development files for developing Unity Asset Server applications.
Group: Applications/Engineering
# You need all the BuildRequires for the development version
Requires: gcc
Requires: perl
%description devel
Install this package of you need to create applications that need to connect to the Unity Asset Server.

This package is not required to install and use the Unity Asset Server from within Unity.

%prep
%setup

%build
(cd postgresql-8.2.5; ./configure CFLAGS="-Os" --prefix=/opt/unity_asset_server --without-docdir --with-pgport=10733 --without-readline )
make -C postgresql-8.2.5
make PG_SOURCE_DIR=postgresql-8.2.5 -C UnityExtensions

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/opt/unity_asset_server
mkdir -p $RPM_BUILD_ROOT/opt/unity_asset_server/log
mkdir -p $RPM_BUILD_ROOT/etc/init.d

make -C postgresql-8.2.5 DESTDIR=$RPM_BUILD_ROOT install
cp unity_build/postgresql.conf.default $RPM_BUILD_ROOT/opt/unity_asset_server/share/postgresql.conf.default
cp unity_build/postgresql.conf.init $RPM_BUILD_ROOT/opt/unity_asset_server/share/postgresql.conf.init
cp unity_build/pg_hba.conf.default $RPM_BUILD_ROOT/opt/unity_asset_server/share/pg_hba.conf.default
cp unity_build/pg_hba.conf.init $RPM_BUILD_ROOT/opt/unity_asset_server/share/pg_hba.conf.init
cp unity_build/db_source.sql.bz2 $RPM_BUILD_ROOT/opt/unity_asset_server/share/db_source.sql.bz2
cp unity_build/db_upgrade_source.sql.bz2 $RPM_BUILD_ROOT/opt/unity_asset_server/share/db_upgrade_source.sql.bz2
cp unity_build/reset_admin_password.sh $RPM_BUILD_ROOT/opt/unity_asset_server/bin/reset_admin_password
chmod 755 $RPM_BUILD_ROOT/opt/unity_asset_server/bin/reset_admin_password
cp unity_build/unity_asset_server.sysvinit $RPM_BUILD_ROOT/etc/init.d/unity_asset_server
chmod 755 $RPM_BUILD_ROOT/etc/init.d/unity_asset_server

make PG_SOURCE_DIR=postgresql-8.2.5 -C UnityExtensions  DESTDIR=$RPM_BUILD_ROOT install

%clean
rm -rf $RPM_BUILD_ROOT

%pre
# Add unitysrv user account
if /usr/sbin/useradd -h 2>&1 | grep -- -r > /dev/null; then
	/usr/sbin/useradd -r -d /opt/unity_asset_server unitysrv 2> /dev/null || :
else
	/usr/sbin/useradd -d /opt/unity_asset_server unitysrv 2> /dev/null || :
fi

# Add unitysrv group
/usr/sbin/groupadd unitysrv 2> /dev/null || :
exit 0

%post

# open port 10733 to the world if apf is installed 
# The Liquid Web VPS hosting service uses apf for firewall configuration
if [ -x /usr/local/sbin/apf ] ; then
	/usr/local/sbin/apf -a tcp:in:d=10733:s=0.0.0.0/0 unity_asset_server >/dev/null || :
fi

mkdir -p /opt/unity_asset_server/log
chown unitysrv.unitysrv /opt/unity_asset_server/log

if [ ! -d /opt/unity_asset_server/data ]; then
	touch /opt/unity_asset_server/log/install.log
	chown unitysrv.unitysrv /opt/unity_asset_server/log/install.log
	
	chown unitysrv /opt/unity_asset_server
	su unitysrv -c '/opt/unity_asset_server/bin/initdb -D /opt/unity_asset_server/data >> /opt/unity_asset_server/log/install.log 2>&1'  || exit 1
	
	su unitysrv -c 'cp /opt/unity_asset_server/share/postgresql.conf.default /opt/unity_asset_server/data/postgresql.conf'
	su unitysrv -c 'cp /opt/unity_asset_server/share/pg_hba.conf.default /opt/unity_asset_server/data/pg_hba.conf'

	chown root /opt/unity_asset_server
	
	if [ -x /sbin/service ] ; then
		/sbin/service unity_asset_server start
	else
		/etc/init.d/unity_asset_server start
	fi
	
	sleep 10 # wait for database to come up
	
	(bunzip2 -c < /opt/unity_asset_server/share/db_source.sql.bz2 | /opt/unity_asset_server/bin/psql -U unitysrv -p 10733 -d template1) >> /opt/unity_asset_server/log/install.log 2>&1 || exit 1
	/opt/unity_asset_server/bin/vacuumdb  -U unitysrv -a -z >> /opt/unity_asset_server/log/install.log 2>&1 || exit 1
else
	su unitysrv -c 'cp /opt/unity_asset_server/data/postgresql.conf /opt/unity_asset_server/data/postgresql.conf~'
	su unitysrv -c 'cp /opt/unity_asset_server/data/pg_hba.conf /opt/unity_asset_server/data/pg_hba.conf~'
	su unitysrv -c 'cp /opt/unity_asset_server/share/postgresql.conf.default /opt/unity_asset_server/data/postgresql.conf'
	su unitysrv -c 'cp /opt/unity_asset_server/share/pg_hba.conf.default /opt/unity_asset_server/data/pg_hba.conf'

	if [ -x /sbin/service ] ; then
		/sbin/service unity_asset_server start
	else
		/etc/init.d/unity_asset_server start
	fi
	sleep 10 
	
	# Recreate template1 from scratch:
	(/opt/unity_asset_server/bin/psql -U unitysrv -p 10733 -d template1 -c 'DROP SCHEMA public CASCADE;' ) >> /opt/unity_asset_server/log/install.log 2>&1
	(/opt/unity_asset_server/bin/psql -U unitysrv -p 10733 -d template1 -c 'CREATE SCHEMA public;' ) >> /opt/unity_asset_server/log/install.log 2>&1
	(bunzip2 -c < /opt/unity_asset_server/share/db_source.sql.bz2 | /opt/unity_asset_server/bin/psql -U unitysrv -p 10733 -d template1) >> /opt/unity_asset_server/log/install.log 2>&1
	
	# Upgrade functions in databases
	for database in template1 `/opt/unity_asset_server/bin/psql -U unitysrv -p 10733 -d postgres -c 'select databasename from all_databases__view' -A -t`
	do
		(bunzip2 -c < /opt/unity_asset_server/share/db_upgrade_source.sql.bz2 | /opt/unity_asset_server/bin/psql -U unitysrv -p 10733 -d $database) >> /opt/unity_asset_server/log/install.log 2>&1 || exit 1
	done
fi

/sbin/chkconfig --add unity_asset_server
/sbin/chkconfig unity_asset_server on

echo "Unity asset server is now installed and running."
echo "Please run /opt/unity_asset_server/bin/reset_admin_password to set the administrator password"

exit 0

%preun
if [ $1 = 0 ]; then
	if [ -x /sbin/service ] ; then
		/sbin/service unity_asset_server stop > /dev/null 2>&1
	else
		/etc/init.d/unity_asset_server stop > /dev/null 2>&1
	fi
	/sbin/chkconfig --del unity_asset_server
fi

# delete our port 10733 rule if apf is installed
# The Liquid Web VPS hosting service uses apf for firewall configuration
if [ -x /usr/local/sbin/apf ] ; then
	/usr/local/sbin/apf -u tcp:in:d=10733:s=0.0.0.0/0 >/dev/null || :
fi

%files
%defattr(-,root,root,-)
/opt/unity_asset_server/bin
/opt/unity_asset_server/lib/*.so*
/opt/unity_asset_server/lib/postgresql/*
/opt/unity_asset_server/share
/etc/init.d/unity_asset_server
%doc /opt/unity_asset_server/man

%files devel
/opt/unity_asset_server/include
/opt/unity_asset_server/lib/*.a

